/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <phk@FreeBSD.ORG> wrote this file.  As long as you retain this notice you
 * can do whatever you want with this stuff. If we meet some day, and you think
 * this stuff is worth it, you can buy me a beer in return.   Poul-Henning Kamp
 * ----------------------------------------------------------------------------
 * $Id: configkit_src.h,v 1.2 2005/09/05 07:32:54 phk Exp $
 *
 * Config source stuff
 *
 */

#ifndef _CONFIGKIT_SRC_H_
#define _CONFIGKIT_SRC_H_ 1

typedef int ck_printf_t(struct ck_args *, const char *fmt, va_list ap);

/*
 * This structure contains the status for each
 * of the sources of config info currently in use.
 */
struct ck_src {
	LIST_ENTRY(ck_src)	list;
	char			*buf;
	struct ck_tree		*cft;
	struct ck_args		cfa;

	ck_printf_t		*print;
	void			*priv;

	int			ntok;
	char			**tok;
	void			*srcpriv;

	char			tree[BUFSIZ];
};

/*
 * Config Source functions (ck_src.c)
 */

struct ck_src *ck_SrcCreate(struct ck_tree *cft, ck_printf_t *func, void *priv);
void ck_SrcDestroy(struct ck_src *cf);
void ck_SrcFeed(struct ck_src *cf, const void *buf, int len);
void ck_SrcFd(struct ck_tree *cft, FILE *fout, int fd);


#endif /* _CONFIGKIT_SRC_H_ */
